	ORG $1001-2
	DW $1001
	
astack	= $E0
xstack	= $E1
ystack	= $E2

voldown_tab	= $C2
;                
shutdown	= $C5
timer		= $C6

dest_ptr	= $D0
src_ptr		= $D2
src_ptr2	= $D4
wipe_ptr	= $D6

	DW $100B,0
	DB $9E,"4109",0,0,0
	
start	SEI
	STA $FF3F
	;
	; --------------------
	;
	LDX #$04
irqc1	LDA irq_null,x		; copy irq to $0110 area
	STA $0110,x
	;
	DEX
	BPL irqc1
	;
	LDX #irq_digi_end - irq_digi
irqc2	LDA irq_digi,x
	STA $10,x
	DEX
	BPL irqc2
	;
	LDX #irq_digi_nextbyte_end - irq_digi_nextbyte
irqc3	LDA irq_digi_nextbyte,x
	STA $0210,x
	DEX
	BPL irqc3
	;
	; --------------------
	;
	JSR PLAYER_INIT
	;
	LDA #voldown_table & 255
	STA voldown_tab 
	LDA #voldown_table >> 8
	STA voldown_tab+1 
	;
	JSR digi_init
	;
	; --------------------
	;
	JSR digi_stop
	;
mainloop
	LDX #$0f
xx1	LDA $48,x
	STA $0C00,x
	DEX
	BPL xx1
	;
ntsc3	LDA #39		; $27 296-256 -> (40)
sync0	CMP $FF1D
	BCS sync0
	;
	;LDA #$44
	;STA $FF19
	;
	JSR PLAYER
	;
	;LDA #$00
	;STA $FF19
	;        
	LDA #62		; $4E-16
sync1	CMP $FF1D
	BCS sync1
	;        
	;DEC $FF19
	JSR PLAYER_SOUND
	;INC $FF19
	;
ntsc5	LDA #140	; $9C-16
sync2	CMP $FF1D
	BCS sync2
	;
	;DEC $FF15
	JSR PLAYER_SOUND
	;INC $FF15
	;        
	; ------------
	;
	;DEC $FF19
	;
	;INC $FF19
	;
ntsc6	LDA #218	; $EA-16
sync3	CMP $FF1D
	BCS sync3
	;
	;DEC $FF19
	JSR PLAYER_SOUND
	;INC $FF19
	;        
	; ------------
	;
	;DEC $FF19
	;
	;
	;INC $FF19
	;
	LDA $FF1D
ntsc7	CMP #218		; $EA-16
	BCC skip_sync4
	;
	LDA #$08
sync4	CMP $FF1D
	BCC sync4
	;
	; --------------
	;
skip_sync4
	LDA $4A
	CMP #$DA
	BNE not_over
	LDA $4B
	CMP #$7C
	BNE not_over
	JMP $FFF6
not_over	
	JMP mainloop

digi_stop
	SEI
	;
	LDA #$A2
	STA $FF0A
	;
	LDA #$00
	STA $FF0B
	;
	LDA #$10
	STA $FFFE
	LDA #$01		; irq_null (relocated address!)
	STA $FFFF
	;
	CLI
	;
	RTS
;	;
;	; --- volume down
;	;
;vol_down
;	INC dont_allow_digi_start+1 	; disable digi start command
;	;
;	LDA $FFFF
;	CMP #$01			; wait until current digi note stops
;	BNE ve
;	;
;	LDA #$A5			; LDA $00 opcode
;	STA digi_note_length		; stop digi completely
;	;  
;	LDX vd_slow+1
;	INX
;	CPX #$03
;	BNE *+4
;	LDX #$00
;	STX vd_slow+1
;	;
;vd_slow	LDA #$00			; slow down to 3 frames
;	BNE ve
;	;
;	LDA voldown_tab			; go through voldown table
;	CLC
;	ADC #$09			; 9 bytes at a time
;	STA voldown_tab
;	BCC *+4
;	INC voldown_tab+1
;	;              
;	LDA voldown_tab
;	CMP #voldown_table_end & 255
;	BEQ final_jump
;	;
;ve	RTS
;	;
;final_jump
;	;
;	LDX #$00
;	TAX
;fj1	STA $0F00,x
;	INX
;	BNE fj1
;	;
;	SEI
;	LDA $FCFD
;	CMP #$4C
;	BEQ do_final_jump
;	JMP $FFF6
;do_final_jump
;	JMP $FCFD
	
	;
	include "digiplay.asm"
	include "digimusic.asm"
	include "!player.asm"
	include "music.asm"
	;
	
	; PAL  (40), 62, 140, 218
	; NTSC ( 3), 62, 128, 193

voldown_table
	include "voldown\voldown_hex.asm"
voldown_table_end
	DB $AA
;[eof]