;
; LOD Player Version 2 - modified for CD4
; Coded by Csabo of LOD
;
; feel free to hack it & use it
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

freqs = $0500

freqs_add
	DB 07,57,54,51, 48,45,43,40, 38,36,34,32 ; C0   00
	DB 31,28,27,25, 24,23,21,21, 19,18,17,16 ; C1    12
	DB 15,14,14,12, 12,12,10,10, 10,09,08,08 ; C2    24
	DB 08,07,07,06, 06,06,05,05, 05,04,05,04 ; C3    36
	DB 03,04,03,04, 03,02,03,03, 02,02,02,02 ; C4    48
	DB 02,02,02,02+24			 ; C5-D5 60 (63=off)
	
; Variables
base = $48
PCH1		= base + $00	; channel data pattern pointers
PCH2		= base + $01
CH1		= base + $02	; channel data pointers
CH2		= base + $04

TICK1		= base + $06	; fine tick counters
TICK2		= base + $07
NOTE1		= base + $08	; note counters
NOTE2		= base + $09
NOTELEN1	= base + $0A	; current note lengths
NOTELEN2	= base + $0B

INS_TYPE1	= base + $12
INS_TYPE2	= base + $13
TONE1		= base + $14
TONE2		= base + $15
TONE_PREV1	= base + $16
TONE_PREV2	= base + $17
ARP_CNT1	= base + $18
;ARP_CNT2	= base + $19

VOL_TAB		= base + $1A ; 16 bit

NOISE		= base + $1C
;VOLUME		= base + $1D 
VOLTAB_CNT	= base + $1E

glide_freq_current	= base + $20	; 24 bit values
glide_freq_dest		= base + $23
glide_freq_diff		= base + $26
glide_add		= base + $29

; COMMAND BYTES

;END_MARK	= $FF	; not used :-) no patterns or restart
;RETRIG		= $FE
SET_VOLTAB	= $FD
;SET_SLIDE	= $FC
SET_ARP		= $FB

DIGI_START	= $FA
DIGI_STOP	= $F9

SETINS		= $F0
SETVOL		= $E0
SETLEN		= $40

; Constants
base_note = 0
C0	= base_note + 0
Ci0	= base_note + 1	
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2 = base_note + 24
Ci2 = base_note + 25
D2 = base_note + 26
Di2 = base_note + 27
E2 = base_note + 28
F2 = base_note + 29
Fi2 = base_note + 30
G2 = base_note + 31
Gi2 = base_note + 32
A2 = base_note + 33
Ai2 = base_note + 34
B2 = base_note + 35

C3 = base_note + 36
Ci3 = base_note + 37
D3 = base_note + 38
Di3 = base_note + 39
E3 = base_note + 40
F3 = base_note + 41
Fi3 = base_note + 42
G3 = base_note + 43
Gi3 = base_note + 44
A3 = base_note + 45
Ai3 = base_note + 46
B3 = base_note + 47

C4 = base_note + 48
Ci4 = base_note + 49
D4 = base_note + 50
Di4 = base_note + 51
E4 = base_note + 52
F4 = base_note + 53
Fi4 = base_note + 54
G4 = base_note + 55
Gi4 = base_note + 56
A4 = base_note + 57
Ai4 = base_note + 58
B4 = base_note + 59

C5 = base_note + 60
Ci5 = base_note + 61
D5 = base_note + 62

OFF = 63

;-----

PLAYER_INIT
	;         
	; *** Freq init
	;              
	LDA #$00
	CLC
	ADC freqs_add
	STA freqs
	LDA #$00
	ADC #$00
	STA freqs+1
	;
	LDX #$00
	LDY #$01
	;
freq_init
	LDA freqs,x
	CLC
	ADC freqs_add,y
	STA freqs+2,x
	INX
	LDA freqs,x
	ADC #$00
	STA freqs+2,x
	INX
	INY
	CPY #64
	BNE freq_init
	;
PLAYER_INIT_2 
	LDX #$FF
	STX VOLTAB_CNT
	;STX VOLUME
	INX
	STX NOTE1
	STX NOTE2
	STX PCH1
	STX PCH2
	INX
	STX NOTELEN1
	STX NOTELEN2
	;
	;JSR advance_ch1
	;JSR advance_ch2
	LDA #Channel1 & 255
	STA CH1
	LDA #Channel1 >> 8
	STA CH1+1
	;
	LDA #Channel2 & 255
	STA CH2
	LDA #Channel2 >> 8
	STA CH2+1
	;
	; ---
	;
	LDA #vol_default & 255
	STA VOL_TAB
	LDA #vol_default >> 8
	STA VOL_TAB+1
	;
	RTS

;res_1	LDY #$00
;	DB $2C
;	;
;advance_ch1
;	LDY PCH1
;	LDA Channel1+1,y	; HI byte
;	BEQ res_1
;	STA CH1 + 1
;	;
;	LDA Channel1,y	; LO byte
;	STA CH1
;	;
;	INY
;	INY
;	STY PCH1
;	;
;	RTS
	
;res_2	LDY #$00
;	DB $2C
;	;
;advance_ch2
;	LDY PCH2
;	LDA Channel2+1,Y
;	BEQ res_2
;	STA CH2 + 1
;	;
;	LDA Channel2,y
;	STA CH2
;	;
;	INY
;	INY
;	STY PCH2
;	;
;	RTS

	;
	;##################
	;     
PLAYER
	;------------------
	INC NOTE1
	INC ARP_CNT1
	;
	LDA NOTE1
	CMP NOTELEN1
	BEQ next_note1
	JMP channel2
	;
;new_pattern1
;	JSR advance_ch1
	;
next_note1
	LDY #$00
	STY NOTE1		; reset note counter
	STY TICK1
	STY ARP_CNT1		; reset arp counter
	;
	LDA (CH1),y		; get byte
	INY
	;
;	CMP #END_MARK		; $FF goes to new pattern
;	BEQ new_pattern1
	;
;	CMP #$FE
;	BNE pl_10
;	;
;	LDA #$80
;	STA click+1
;	;
;	LDA (CH1),y		; get byte
;	INY
;	;
pl_10	CMP #SET_VOLTAB
	BNE pl_12
	;
	LDA #$FF		; reset voltab counter
	STA VOLTAB_CNT
	;STA VOLUME		; disable SET volume
	;
	LDA (CH1),y		; get lo byte
	STA VOL_TAB
	INY
	;
	LDA (CH1),y		; get hi byte
	STA VOL_TAB+1
	INY
	;
	LDA (CH1),y		; get byte
	INY
	;
;pl_11	
;	CMP #$FC
;	BNE pl_12
;	;
;	LDA (CH1),y		; get SLIDE lo byte
;	STA slide
;	INY
;	;
;	LDA (CH1),y		; get SLIDE hi byte
;	STA slide+1
;	INY
;	;
;	LDA (CH1),y		; get byte
;	INY
;	;
pl_12	
	CMP #SET_ARP
	BNE pl_14
	;
	LDA (CH1),y		; get arp lo byte
	STA arp_ptr1+1
	INY
	;
	;LDA (CH1),y		; get arp hi byte
	;STA arp_ptr1+2
	;INY
	;
	LDA (CH1),y		; get byte
	INY
	;
pl_14	CMP #$F0		; instrument change?
	BCC pl_01
	;
	AND #$0F		; keep lower 4 bits
	STA INS_TYPE1   	; store instrument type
	;
	LDA (CH1),y		; get byte
	INY
	;
pl_01	
;	CMP #$E0
;	BCC pl_05
;	;
;	AND #$0F
;	STA VOLUME		; store direct volume set value
;	;
;	LDA (CH1),y		; get byte
;	INY
;	;
;pl_05	
	CMP #$40		; set note length?
	BCC pl_02
	;
	SEC
	SBC #$40
	STA NOTELEN1
	;
	LDA (CH1),y
	INY
	;
pl_02	; - store note!
	;
	LDX TONE1		; keep previous
	CPX #OFF
	BEQ done_store_1
	STX TONE_PREV1
done_store_1
	STA TONE1
	;
	; --- advance pointer
	;
	TYA
	CLC
	ADC CH1
	STA CH1
	BCC noi_1
	INC CH1 + 1
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel2
	INC NOTE2
	;INC ARP_CNT2
	;
	LDA NOTE2
	CMP NOTELEN2
	BEQ next_note2
	BNE pl_50
	;
;new_pattern2
;	JSR advance_ch2
	;
next_note2
	LDY #$00
	STY NOTE2		; reset note counter
	STY TICK2
	;STY ARP_CNT2		; reset arp counter
	;
	LDA (CH2),y		; get byte
	INY
	;
;	CMP #END_MARK		; $FF goes to new pattern
;	BEQ new_pattern2
	;
;	CMP #SET_ARP
;	BNE pl_24
;	;
;	LDA (CH2),y		; get arp lo byte
;	STA arp_ptr2+1
;	INY
;	;
;	LDA (CH2),y		; get arp hi byte
;	STA arp_ptr2+2
;	INY
;	;
;	LDA (CH2),y		; get byte
;	INY
;	;
;pl_24	
	CMP #DIGI_START
	BNE pl_2a
	;
dont_allow_digi_start
	LDA #$00
	BNE skip_digi_start
	;              
	JSR digi_start 
	;
	LDA #$C6		; DEC $00 opcode
	STA digi_note_length
	;                  
skip_digi_start
	LDA (CH2),y		; get byte
	INY
	;
pl_2a	CMP #DIGI_STOP
	BNE pl_2b
	;
	JSR digi_stop
	;
	LDA #$A5		; LDA $00 opcode
	STA digi_note_length
	;
	LDA (CH2),y		; get byte
	INY
	;
pl_2b	CMP #$F0		; instrument change?
	BCC pl_21
	;
	AND #$0F		; keep lower 4 bits
	STA INS_TYPE2   	; store instrument type
	;
	LDA (CH2),y		; get byte
	INY
	;
pl_21	
;	CMP #$E0
;	BCC pl_25
;	;
;	AND #$0F
;	STA VOLUME
;	;
;	LDA (CH2),y		; get byte
;	INY
;	;
;pl_25	
	CMP #$40		; set note length?
	BCC pl_22
	;
	SEC
	SBC #$40
	STA NOTELEN2
	;
	LDA (CH2),y
	INY
	;
pl_22	; - store note!
	;
	LDX TONE2
	CPX #OFF
	BEQ done_store_2
	STX TONE_PREV2
done_store_2
	STA TONE2
	;
	; --- advance pointer
	;
	TYA
	CLC
	ADC CH2
	STA CH2
	BCC noi_2
	INC CH2 + 1
noi_2	;     
	;
	;    
pl_50	
	;
digi_note_length
	LDA note_length		; for digi
	BNE PLAYER_SOUND
	;
	SEI
	LDA #$02
	STA $FFFF		; digi player will go to NextByte
	CLI
	;	
PLAYER_SOUND
	LDY VOLTAB_CNT
	INY
	LDA (VOL_TAB),y
	BPL noi_3		; check for $FF
	LDY #$00		; reached, so warp
noi_3	STY VOLTAB_CNT
	;
	; --- SOUND PROCESSING
	;
	LDA #$20		; assume no noise
	STA NOISE
	;
	LDX #$00		; channel 0
	JSR sound
	;
	STA F1LO
	STY F1HI_x+1
	;
	LDA F1HI
	AND #$FC
F1HI_x	ORA #$00
	STA F1HI
	;
	LDX #$01		; channel 1
	JSR sound
	STA F2LO
	STY F2HI
	;
	; ---
	;    
	INC TICK1
	INC TICK2
	;
	; ---
	;       
	LDA $FFFF		; is digi playing?
	BEQ no_setvol		; then don't set volume
	;
	;LDA VOLUME
	;BPL pl_70		; check SET volume
	LDY VOLTAB_CNT
	LDA (VOL_TAB),Y		; nope, read from envelope
	;
	TAY
	LDA (voldown_tab),y
	;
pl_70	ORA #$10
	ORA NOISE
;click	ORA #$00
	STA $FF11
	;
	;LDA #$00
	;STA click+1
	;
no_setvol
	RTS
	;
sound	LDA INS_TYPE1,x
	CMP #$06
	BEQ glide_0
	CMP #$04
	BEQ arp  
	CMP #$05
	BEQ vib
	CMP #$03
	BEQ bassdrum
	CMP #$02
	BEQ snare
	CMP #$07
	BEQ hihat
	;
normal	LDA TONE1,x		; normal note
lookup	ASL a
	TAX
	LDA freqs,x
	LDY freqs+1,x
	RTS
	
arp_res	AND #$0F		; low byte is new position
	STA ARP_CNT1;,x
	;
arp	LDY ARP_CNT1;,x		; load current arp counter
	;
;	CPX #$00		; check which channel
;	BEQ arp_ptr1
;arp_ptr2
;	LDA arp_lead,y		; for channel 2 (self-mod)
;	JMP arp_1
arp_ptr1
	LDA arpX,y		; for channel 1 (self-mod)
arp_1
	BMI arp_res		; check for negative numbers
	CLC
	ADC TONE1,x
	;CMP #OFF
	;BCC *+5
	;JMP *
	JMP lookup
	
glide_0	JMP glide
	
	;
;slider	;
;;	LDA slide
;;	BNE sl_01
;;	DEC slide+1
;;sl_01	DEC slide
;	;  
;	LDA TICK1,x
;	BNE add1
;	;
;	LDA slide
;	LDY slide+1
;	RTS
;	;
;add1	LDA TONE1,x
;	ASL a
;	TAX
;	LDY freqs+1,x
;	LDA freqs,x
;	CLC
;	ADC #$01
;	BCC sl_03
;	INY
;sl_03	RTS
	;
snare	LDA #$40		; turn on noise bit
	STA NOISE
	;
	LDA TONE1,x		; look up note freq
	ASL a
	TAY
	;  
	LDA TICK1,x
	ASL a
	TAX
	LDA snare_freq,x	; 16 bit add: add snare freq
	CLC
	ADC freqs,y       
	PHA
	LDA snare_freq+1,x
	ADC freqs+1,y
	CMP #$04
	BNE xx1
	JMP *
xx1	TAY
	PLA
	RTS
	
bassdrum
	LDA TICK1,x
	CMP #$10
	BCS hihat_2
	;
	ASL a
	TAX
	LDA bass_freq,x
	LDY bass_freq+1,x
	RTS
	
hihat
	LDA TICK1,x
	CMP #$04
	BCC hihat_1
	;
hihat_2	LDA #$FE
	LDY #$03
	RTS
	;
hihat_1	ASL a
	TAX
	LDA hihat_freq,x
	LDY hihat_freq+1,x
	;
	LDX #$40		; turn on noise bit
	STX NOISE
	;
	RTS

vib	LDA NOTE1,x
	AND #$07
	TAY
	LDA vibrato,y
	BMI vib1
	;
	STA vib2+1
	;
	LDA TONE1,x
	ASL a
	TAX
	LDY freqs+1,x
	LDA freqs,x
	CLC
vib2	ADC #$01
	BCC vib3
	INY
vib3	RTS
	;
vib1	AND #$7F
	;
	STA vib4+1
	;
	LDA TONE1,x
	ASL a
	TAX
	LDY freqs+1,x
	LDA freqs,x
	SEC
vib4	SBC #$01
	BCS vib5
	DEY
vib5	RTS

glide_2	
	;JMP normal
	JMP vib

glide	LDA TICK1,x
	BEQ glide_1
	;
	;
	;
	CMP #$08			; change this to determine glide length
	BCS glide_2
	;
	LDA glide_add
	BMI glide_sub
	;
	LDA glide_freq_current
	CLC
	ADC glide_freq_diff
	STA glide_freq_current
	LDA glide_freq_current+1
	ADC glide_freq_diff+1
	STA glide_freq_current+1
	LDA glide_freq_current+2
	ADC glide_freq_diff+2
	STA glide_freq_current+2
	;
	LDA glide_freq_current+1
	LDY glide_freq_current+2
	;
	RTS
	;
glide_sub
	LDA glide_freq_current
	SEC
	SBC glide_freq_diff
	STA glide_freq_current
	LDA glide_freq_current+1
	SBC glide_freq_diff+1
	STA glide_freq_current+1
	LDA glide_freq_current+2
	SBC glide_freq_diff+2
	STA glide_freq_current+2
	;
	LDA glide_freq_current+1
	LDY glide_freq_current+2
	;
	RTS
	;
	; first iteration
	;
glide_1	LDA TONE1,x			; look up destination freq
	ASL a
	TAY
	LDA freqs,y
	STA glide_freq_dest+1
	LDA freqs+1,y   
	STA glide_freq_dest+2
	;
	LDA TONE_PREV1,x		; look up previous freq
	ASL a
	TAY
	LDA freqs,y
	STA glide_freq_current+1
	LDA freqs+1,y   
	STA glide_freq_current+2
	;
	LDA #$00             		; clear low bytes of 24 bit values
	STA glide_freq_dest
	STA glide_freq_current
	STA glide_freq_diff
	;
	LDA TONE1,x
	CMP TONE_PREV1,x
	BCS glide_down
	;
	; up
	;
	LDA glide_freq_dest+1		; diff = dest - current
	SEC
	SBC glide_freq_current+1
	STA glide_freq_diff+1
	LDA glide_freq_dest+2
	SBC glide_freq_current+2
	STA glide_freq_diff+2
	;
	LDA #$00
gl_up	STA glide_add
	;
	LSR glide_freq_diff+2		; 24 bit div routine
	ROR glide_freq_diff+1
	ROR glide_freq_diff
	LSR glide_freq_diff+2
	ROR glide_freq_diff+1
	ROR glide_freq_diff
	LSR glide_freq_diff+2
	ROR glide_freq_diff+1
	ROR glide_freq_diff
	LSR glide_freq_diff+2
	ROR glide_freq_diff+1
	ROR glide_freq_diff
	;
	LDA glide_freq_current+1
	LDY glide_freq_current+2
	;
	RTS

glide_down
	LDA glide_freq_current+1	; diff = current - dest
	SEC
	SBC glide_freq_dest+1
	STA glide_freq_diff+1
	LDA glide_freq_current+2
	SBC glide_freq_dest+2
	STA glide_freq_diff+2
	;
	LDA #$80     
	BNE gl_up			; always jump

vibrato
	DB 3,1,$81,$83,$83,$81,1,3

	; addresses are referred to by low byte
	; so all the arp tables must be in a 256 byte page	
arpX	DB 0,12,24,$80
arpX2	DB 0,12, 0,$80

arp36	DB 24,18,15,12,6,3,0,$81
arp37	DB 24,19,15,12,7,3,0,$81
arp58	DB 24,20,17,12,8,5,0,$81
	
snare_freq
	DW $01C0,$01B8,$01B0,$01A8
	DW $01A0,$0198,$0190,$0188
	DW $0180,$0170,$0160,$0140
	DW $0120,$0100,$0080,$0002
	
	;DW $01F8,$01F2,$01E7,$01D5
	;DW $01C2,$01B0,$0190,$0170
	;DW $0150,$0125,$0100,$00C0
	;DW $0080,$0040,$0020,$0011
	;
	;DW $01F8,$01F2,$01E7,$01D5
	;DW $01C2,$01B0,$0190,$0170
	;DW $0150,$0125,$0100,$00C0
	;DW $0080,$0040,$0020,$0011
	;
	DW 0,0,0,0
	DW 0,0,0,0
	DW 0,0,0,0
	DW 0,0,0,0
	
bass_freq ; (16)
	DW $0300, $02C0, $0280, $0240, $0200, $01C0, $0180, $0140
	DW $0100, $00E0, $00C0, $00A0, $0080, $0060, $0040, $0020
	
hihat_freq ; (8)
	DW $03F8, $03F0, $03E8, $03E0

vol_default
	DB 8,8,8,8, 7,7,7,7, 6,6,6,6, 5,5,5,5, 5,5,6,7
	DB 8,8,8,8, 8,8,8,8, 8,8,8,8, 8,8,8,8, 8,8,8,8
	DB 8,8,8,8, 7,7,7,7, 6,6,6,6, 5,5,5,5, 5,5,6,7
	DB $FF
	
vol_piano            
	DB 8,8,8,8, 8,8,8,7, 7,7,7,7, 7,7,6,6, 6,6,6,6
	DB 6,5,5,5, 5,5,5,5, 5,5,4,4, 4,4,4,4, 4,4,3,3
	DB 3,3,3,3, 3,3,2,2, 2,2,2,2, 2,2,2,3, 4,5,6,7
	DB $FF
	
vol_none
	DB 8,8,8,8, $FF
	DB 0

