
	ALIGN 256	
kick_sample
	include "samples/kick.asm"
kkhh_sample
	include "samples/kick_hihat.asm"
hiht_sample
	include "samples/hihat.asm"
snar_sample
	include "samples/snare.asm"
scra_sample
	include "samples/scratch_new.asm"

	; scratch re-sampled for NTSC speed	
scra_sample_ntsc
	include "samples/scratch_new_ntsc.asm"
	
sample_data_end

;	;ALIGN 256
;null_sample
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
;	DB $04,$04,$04,$04,$04,$04,$04,$04, $04,$04,$04,$04,$04,$04,$04,$04
	
kick = ( kick_sample >> 8 ) ;  4*2
kkhh = ( kkhh_sample >> 8 ) ;  4*2 
hiht = ( hiht_sample >> 8 ) ;  3
snar = ( snar_sample >> 8 ) ;  6*2
scra = ( scra_sample >> 8 ) ; 19*2

scra_ntsc = ( scra_sample_ntsc >> 8 ) ; 14*2
 
;null = ( null_sample >> 8 ) ;  1

	ALIGN 256
	DB 0
	
DTEMPO = 5

;xInitQuiet
;	DB null, 01, DTEMPO * 6
;	DB 0
	
xBeat
	DB kkhh, 08, DTEMPO * 3
	DB hiht, 03, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 2
	DB kick, 08, DTEMPO
	;
	DB kkhh, 08, DTEMPO * 3
	DB kkhh, 08, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 3
	;
	DB kkhh, 08, DTEMPO * 3
	DB hiht, 03, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 2
	DB kick, 08, DTEMPO
	;
	DB kkhh, 08, DTEMPO * 3
	DB kkhh, 08, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 2
	DB kick, 08, DTEMPO
	;
	DB 0
	
xBreak1
	DB kkhh, 08, DTEMPO * 3
	DB hiht, 03, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 2
	DB kick, 08, DTEMPO
	;
	DB kkhh, 08, DTEMPO * 3
	DB kkhh, 08, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 3
	;
	DB kkhh, 08, DTEMPO * 3
	DB kkhh, 08, DTEMPO * 3
	DB scra, 38, DTEMPO * 6 
	DB kkhh, 08, DTEMPO * 3
	DB kkhh, 08, DTEMPO * 3
	DB scra, 38, DTEMPO * 6 
	DB 0
	
xBreak2
	DB kkhh, 08, DTEMPO * 3
	DB hiht, 03, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 2
	DB kick, 08, DTEMPO
	;
	DB kkhh, 08, DTEMPO * 3
	DB kkhh, 08, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 3
	;
	DB kkhh, 08, DTEMPO * 2
	DB kick, 08, DTEMPO    
	DB hiht, 03, DTEMPO * 2
	DB kick, 08, DTEMPO
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 2
	DB kick, 08, DTEMPO
	;
	DB kkhh, 08, DTEMPO * 2
	DB kick, 08, DTEMPO    
	DB hiht, 03, DTEMPO * 2
	DB snar, 12, DTEMPO
	DB snar, 12, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	;
	DB 0
	
xScra
	DB scra, 38, DTEMPO * 6 
	DB scra, 38, DTEMPO * 6 
	DB scra, 38, DTEMPO * 6 
	DB scra, 38, DTEMPO * 3
	DB snar, 12, DTEMPO
	DB snar, 12, DTEMPO 
	DB snar, 12, DTEMPO
	DB 0
	
xBeatEnd
	DB kkhh, 08, DTEMPO * 3
	DB hiht, 03, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 2
	DB kick, 08, DTEMPO
	;
	DB kkhh, 08, DTEMPO * 3
	DB kkhh, 08, DTEMPO * 3
	DB snar, 12, DTEMPO * 3
	DB hiht, 03, DTEMPO * 3
	;
	DB kick, 08, DTEMPO * 12
	;
	DB 0

	ALIGN 256	
Orders                                 
	DW xScra  		; intro
	;
	DW xBeat,xBeat,xBeat,xBeat
	;
	DW xBeat,xBreak1	; arp
	DW xBeat,xBreak2
	;
	DW xBeatEnd		; ending
	;
	DW 0
